package Game.Entity
{
	import Game.GameScene;
	
	import starling.animation.Transitions;
	import starling.core.Starling;
	import starling.display.Image;
	import starling.display.Sprite;

	public class Arrow extends GameEntity
	{
		public var x:Number;
		public var y:Number;
		public var dx:Number;
		public var dy:Number;
		
		public var image:Image;
		public var sprite:Sprite;
		public var target:Unit;
		
		public function Arrow()
		{
			image = new Image(Root.assets.getTexture("arrow"));
			image.pivotX = image.width*0.5;
			image.pivotY = image.height*0.5;
			
			sprite = new Sprite();
			sprite.addChild(image);
		}
		
		public function initArrow(game:GameScene, x:Number, y:Number, target:Unit):void {
			super.init(game);
			this.x = dx = x;
			this.y = dy = y;
			this.target = target;
			
			sprite.x = x;
			sprite.y = y;
			game.arrowLayer.addChild(sprite);
			
			var arcHeight:Number = Math.min(y, target.y) - 30;
			var duration:Number = 0.5;//game.getDistance(x, y, target.x, target.y)*0.005;
			Starling.juggler.tween(sprite, duration, {x:target.x, onComplete:hitTarget});
			Starling.juggler.tween(sprite, duration*0.5, {y:arcHeight, transition:Transitions.EASE_OUT});
			Starling.juggler.tween(sprite, duration*0.5, {y:target.y, transition:Transitions.EASE_IN, delay:duration*0.5});
		}
		
		public override function deInit():void {
			game.arrowLayer.removeChild(sprite);
		}
		
		public override function update(dt:Number):void {
			image.rotation = game.getAngle(dx, dy, sprite.x, sprite.y);
			dx = sprite.x;
			dy = sprite.y;
		}
		
		public function hitTarget():void {
			target.hit(40);
			active = false;
		}
	}
}