package Game.Entity
{
	import Game.GameScene;

	public class EntityPool
	{
		public var active:Vector.<GameEntity>;
		public var reserve:Vector.<GameEntity>;
		public var activeIndex:int;
		public var reserveIndex:int;
		public var game:GameScene;
		
		public function EntityPool()
		{
			active = new Vector.<GameEntity>();
			reserve = new Vector.<GameEntity>();
			activeIndex = 0;
			reserveIndex = 0;
		}
		
		public function init(game:GameScene):void {
			this.game = game;
		}
		
		public function deInit():void {
			while(activeIndex > 0) {
				var entity:GameEntity = active[--activeIndex];
				entity.deInit();
				reserve[reserveIndex++] = entity;
			}
			active.length = 0;
			game = null;
		}
		
		public function addEntity(entity:GameEntity):void {
			active[activeIndex++] = entity;
		}
		
		public function getReserve():GameEntity {
			if(reserveIndex > 0) return reserve[--reserveIndex];
			else return null;
		}
		
		public function update(dt:Number):void {
			var l:int = activeIndex;
			for(var i:int = 0; i < l; i++) {
				var entity:GameEntity = active[i];
				if(!entity.active) {
					entity.deInit();
					active[i] = active[--activeIndex];
					reserve[reserveIndex++] = entity;
					l--; i--;
					active.length = activeIndex;
				} else entity.update(dt);
			}
		}
	}
}