package
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.system.Capabilities;
	
	import starling.core.Starling;
	import starling.events.Event;
	import starling.utils.AssetManager;
	
	//[SWF(width="800", height="600", frameRate="60", backgroundColor="#000")]
	public class Main extends Sprite
	{	
		private var mStarling:Starling;
		
		public function Main()
		{
			if (stage) start();
			else addEventListener(flash.events.Event.ADDED_TO_STAGE, onAddedToStage);
		}
		
		private function start():void
		{
			Globals.main = this;
			Globals.sw = stage.stageWidth;
			Globals.sh = stage.stageHeight;
			Starling.multitouchEnabled = false; // for Multitouch Scene
			Starling.handleLostContext = true; // required on Windows, needs more memory
			
			mStarling = new Starling(Root, stage);
			mStarling.simulateMultitouch = false;
			mStarling.enableErrorChecking = Capabilities.isDebugger;
			mStarling.antiAliasing = 8;
			mStarling.start();
			//mStarling.showStats = true;
			
			// this event is dispatched when stage3D is set up
			mStarling.addEventListener(starling.events.Event.ROOT_CREATED, onRootCreated);
		}
		
		private function onAddedToStage(event:Object):void
		{
			removeEventListener(flash.events.Event.ADDED_TO_STAGE, onAddedToStage);
			start();
		}
		
		private function onRootCreated(event:starling.events.Event, root:Root):void
		{
			// set framerate to 30 in software mode
			if (mStarling.context.driverInfo.toLowerCase().indexOf("software") != -1)
				mStarling.nativeStage.frameRate = 30;
			
			// define which resources to load
			var assets:AssetManager = new AssetManager();
			assets.verbose = Capabilities.isDebugger;
			assets.enqueue(EmbeddedAssets);
			
			root.start(assets);
		}
		
		public function on_activate(e:*):void {
			mStarling.start();
		}
		
		public function on_deactivate(e:*):void {
			mStarling.stop();
		}
	}
}